--www.LacrosseLlama.com presents... Wall Ball DS 		created on 6/6/07
SCREEN_BOTTOM = 0
SCREEN_TOP = 1

PALETTE_BALL = 0
PALETTE_TRAP = 1
PALETTE_END = 2
PALETTE_VERT = 3
PALETTE_HORIZ = 4

SCREEN_WIDTH = 255
SCREEN_HEIGHT= 191
BALL_HEIGHTANDWIDTH = 16
END_HEIGHTANDWIDTH = 32
TRAP_HEIGHTANDWIDTH = 16
MAXIMUM_VELOCITY = 3
VERTPADDLE_HEIGHT = 32
VERTPADDLE_WIDTH = 8
HORIZPADDLE_HEIGHT = 8
HORIZPADDLE_WIDTH = 32

COLOR_WHITE = 0
COLOR_GRAY = 1

play = 1
traps = 1
ballY = SCREEN_HEIGHT - BALL_HEIGHTANDWIDTH
ballX = SCREEN_WIDTH - BALL_HEIGHTANDWIDTH
trapY = {}
trapY[traps] = (SCREEN_HEIGHT/2)- TRAP_HEIGHTANDWIDTH
trapX = {}
trapX[traps] = (SCREEN_WIDTH/2)- TRAP_HEIGHTANDWIDTH + 20
ballYVel = 1
ballXVel = 1
paddleIsVerticle = true

Sprite.LoadPalette( SCREEN_BOTTOM, PALETTE_BALL, "ball.pal" )
Sprite.LoadPalette( SCREEN_BOTTOM, PALETTE_TRAP, "trap.pal" )
Sprite.LoadPalette( SCREEN_BOTTOM, PALETTE_END, "end.pal" )
Sprite.LoadPalette( SCREEN_BOTTOM, PALETTE_VERT, "VertPaddle.pal" )
Sprite.LoadPalette( SCREEN_BOTTOM, PALETTE_HORIZ, "HorizPaddle.pal" )

ModMusic = Music.LoadMod( "1.MOD" )

BGTopText = Screen.LoadTextBG()
BGTopMap = Screen.LoadTileBG()
BGTopMap:LoadPalette( "top.pal" )
BGTopMap:LoadTiles( "top.raw", 256 )
BGTopMap:LoadMap( "top.map", (256/8), (192/8) )

BGIntroTopMap = Screen.LoadTileBG()
BGIntroTopMap:LoadPalette( "introtop.pal" )
BGIntroTopMap:LoadTiles( "introtop.raw", 256 )
BGIntroTopMap:LoadMap( "introtop.map", (256/8), (192/8) )

BGBotMap = Screen.LoadTileBG()
BGBotMap:LoadPalette( "bot.pal" )
BGBotMap:LoadTiles( "bot.raw", 256 )
BGBotMap:LoadMap( "bot.map", (256/8), (192/8) )

BGIntroBotMap = Screen.LoadTileBG()
BGIntroBotMap:LoadPalette( "introbot.pal" )
BGIntroBotMap:LoadTiles( "introbot.raw", 256 )
BGIntroBotMap:LoadMap( "introbot.map", (256/8), (192/8) )

--do intro then map game
ModMusic:Play()

Screen.Initialize( SCREEN_BOTTOM, BGIntroBotMap)
Screen.Initialize( SCREEN_TOP, BGIntroTopMap )

for n=0, 240 do
	  Screen.WaitForVBL()
	  end

Screen.Initialize( SCREEN_BOTTOM, BGBotMap)
Screen.Initialize( SCREEN_TOP, BGTopText, BGTopMap )

BGTopText:SetColor(0)
BGTopText:PrintXY(7,2, "Start")

BallFrames = FrameStrip.Create( SCREEN_BOTTOM, 16, 16, "256" )
BallFrames:LoadBin( "ball.raw", 1 )
Ball = Sprite.Create( BallFrames, 0, PALETTE_BALL, ballX, ballY )

EndFrames = FrameStrip.Create( SCREEN_BOTTOM, 32, 32, "256" )
EndFrames:LoadBin( "end.raw", 1 )
End = Sprite.Create( EndFrames, 0, PALETTE_END, 0, 0 )

VertPaddleFrames = FrameStrip.Create( SCREEN_BOTTOM, 8, 32, "256" )
VertPaddleFrames:LoadBin( "VertPaddle.raw", 1 )
VertPaddle = Sprite.Create( VertPaddleFrames, 0, PALETTE_VERT, 0 - VERTPADDLE_WIDTH, 0 - VERTPADDLE_HEIGHT )

HorizPaddleFrames = FrameStrip.Create( SCREEN_BOTTOM, 32, 8, "256" )
HorizPaddleFrames:LoadBin( "HorizPaddle.raw", 1 )
HorizPaddle = Sprite.Create( HorizPaddleFrames, 0, PALETTE_HORIZ, 0 - HORIZPADDLE_WIDTH, 0 - HORIZPADDLE_HEIGHT )

TrapFrames = FrameStrip.Create( SCREEN_BOTTOM, 16, 16, "256" )
TrapFrames:LoadBin( "trap.raw", 1 )
Trap = {}
Trap[traps] = Sprite.Create( TrapFrames, 0, PALETTE_TRAP, trapX[traps], trapY[traps] )

--wait until user wants to start
while true do
	if Pads.AnyKey() == true or Stylus.Down() == true then
	break
	end
end

BGTopText:PrintXY(20,11, "                       ")

--------------------------main loop--------------------------------------------
play = 1
while play == 1 do

BGTopText:PrintXY(7,2, "Level: " .. traps)
Ball:MoveTo(ballX, ballY )


ballX = ballX + ballXVel
ballY = ballY + ballYVel

	if ballX < 0 then
	ballX = 0
	ballXVel = -ballXVel
	
	
	elseif ballY < 0 then
	ballY = 0
	ballYVel = -ballYVel

	
	elseif ballX > (SCREEN_WIDTH - BALL_HEIGHTANDWIDTH) then
	ballX = SCREEN_WIDTH - BALL_HEIGHTANDWIDTH
	ballXVel = -ballXVel
	
	
	elseif ballY > (SCREEN_HEIGHT - BALL_HEIGHTANDWIDTH) then
	ballY = SCREEN_HEIGHT - BALL_HEIGHTANDWIDTH
	ballYVel = -ballYVel
	end
	
	if Pads.Left() or Pads.Right() or Pads.X() or Pads.B() then
	paddleIsVerticle = false
	elseif Pads.Up() or Pads.Down() or Pads.Y() or Pads.A() then
	paddleIsVerticle = true
	end
	
	if Stylus.Down() then
	
		if paddleIsVerticle then
		HorizPaddle:MoveTo(0 - HORIZPADDLE_WIDTH, 0 - HORIZPADDLE_HEIGHT)
		VertPaddle:MoveTo(Stylus.X() - (VERTPADDLE_WIDTH/2),Stylus.Y() - (VERTPADDLE_HEIGHT/2))
		else
		VertPaddle:MoveTo(0 - VERTPADDLE_WIDTH, 0 - VERTPADDLE_HEIGHT)
		HorizPaddle:MoveTo(Stylus.X() - (HORIZPADDLE_WIDTH/2),Stylus.Y() - (HORIZPADDLE_HEIGHT/2))
		end
	
	end

	if paddleIsVerticle then
		for y = -16, 16 do
			if (Stylus.Y() + y) >= ballY and  (Stylus.Y() + y) <= ballY + BALL_HEIGHTANDWIDTH then
				for x = -4, 4 do
					if Stylus.X() + x >= ballX and Stylus.X() + x <= ballX + BALL_HEIGHTANDWIDTH then
					ballXVel = -ballXVel
					end
				end
			end
		end
	
	else
		for y = -4, 4 do
			if (Stylus.Y() + y) >= ballY and  (Stylus.Y() + y) <= ballY + BALL_HEIGHTANDWIDTH then
				for x = -16, 16 do
					if Stylus.X() + x >= ballX and Stylus.X() + x <= ballX + BALL_HEIGHTANDWIDTH then
					ballYVel = -ballYVel
					end
				end
			end
		end	
	end
	
	for n = 1, traps do
		for i = 0, 16 do
			if ballY + i >= trapY[n] and ballY + 1 <= trapY[n] + 16 then
				for c = 0,16 do	
					if ballX + c >= trapX[n] and ballX + c <= trapX[n] + 16 then
					ballX = SCREEN_WIDTH - BALL_HEIGHTANDWIDTH
					ballY = SCREEN_HEIGHT - BALL_HEIGHTANDWIDTH
						for n = 1, traps do
						
						Trap[n]:SetFrame( TrapFrames, 0 )
						Trap[n]:Free()
						end
					traps = 1
					Trap[traps] = Sprite.Create( TrapFrames, 0, PALETTE_TRAP, trapX[traps], trapY[traps] )
					end
				end
			end
		end
	end
	
	if ballY <= 32 and ballX <= 32 then
	traps = traps + 1
	ballX = SCREEN_WIDTH - BALL_HEIGHTANDWIDTH
	ballY = SCREEN_HEIGHT - BALL_HEIGHTANDWIDTH
		for n = 0, 60 do
		Screen.WaitForVBL()
		end
	
	trapY[traps] = math.random(0 ,SCREEN_HEIGHT)
	trapX[traps] = math.random(0 ,SCREEN_WIDTH)
	Trap[traps] = Sprite.Create( TrapFrames, 0, PALETTE_TRAP, trapX[traps] , trapY[traps])
		if trapY[traps] <= 40 and trapX[traps] <= 40 then
		trapY[traps] = math.random( 40, SCREEN_WIDTH - 20)
		trapX[traps] = math.random( 40, SCREEN_HEIGHT - 20)
		elseif trapY[traps] >= SCREEN_HEIGHT - 20 and trapX[traps] >= SCREEN_WIDTH - 20 then
		trapX[traps] = math.random( 40, SCREEN_WIDTH - 20)
		trapY[traps] = math.random( 40, SCREEN_HEIGHT - 20)
		end
	end
	
          if Pads.Select() then
                    play = 0
          end
	  
	  Screen.WaitForVBL()

end
--------------------end main loop----------------------------------------------
ModMusic:Stop()
ModMusic:Free()
